package com.hcst.youteng.controller;

import com.hcst.youteng.entity.Result;
import com.hcst.youteng.entity.Visit;
import com.hcst.youteng.service.IVisitService;
import com.hcst.youteng.utils.CorpWeChatUtils;
import lombok.extern.slf4j.Slf4j;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.beans.factory.annotation.Value;
import org.springframework.web.bind.annotation.*;

import static com.hcst.youteng.utils.CorpWeChatUtils.getMessage;
import static com.hcst.youteng.utils.CorpWeChatUtils.sendMessageByWeChatId;

/**
 * 官网拜访人群
 */
@Slf4j
@RestController
@RequestMapping("/hcst/youteng/visit")
public class VisitController {

    @Value("${admin.weChat}")
    private String adminWeChat;
    @Autowired
    private IVisitService visitService;

    @PostMapping(value = "/add")
    public Result<Visit> add(@RequestBody Visit visit) {
        Result<Visit> result = new Result<>();
        try {
            visitService.save(visit);
            result.success("添加成功！");
            //通知管理员
			sendMessageByWeChatId(adminWeChat,getMessage(visit));
        } catch (Exception e) {
            log.error(e.getMessage(), e);
            result.error500("操作失败");
        }
        return result;
    }

}
