package com.hcst.youteng.service.impl;

import com.github.qcloudsms.SmsSingleSender;
import com.github.qcloudsms.SmsSingleSenderResult;
import com.github.qcloudsms.httpclient.HTTPException;
import com.hcst.youteng.service.ISmsService;
import com.hcst.youteng.utils.SmsUtil;
import lombok.extern.slf4j.Slf4j;
import org.json.JSONException;
import org.springframework.stereotype.Service;

import java.io.IOException;
import java.util.Map;
@Service
@Slf4j
public class SmsServiceImpl implements ISmsService {

    /**
     * 实例化单发短信对象
     */
    private static SmsSingleSender sender=new SmsSingleSender(SmsUtil.appId, SmsUtil.appKey);

    @Override
    public SmsSingleSenderResult sendAuthCode(Map<String, String> params) {
        //手机号
        String phoneNumber=params.get("phoneNumber");
        //6 位验证码
        String[] authCode={params.get("authCode"),"2"};
        SmsSingleSenderResult smsSingleSenderResult=null;
        try{
            smsSingleSenderResult = sender.sendWithParam(SmsUtil.phonePrefix, phoneNumber, SmsUtil.msgTempId, authCode, SmsUtil.smsSign, "", "");
        } catch (HTTPException | JSONException | IOException e) {
            // HTTP 响应码错误 网络 IO 错误 JSON 解析错误
            log.error(e.getMessage());
        }
        return smsSingleSenderResult;
    }

    @Override
    public Map<String, Object> VerifySmsCode(Map<String, Object> params) {
        return null;
    }

}
