package com.hcst.youteng.utils;

import org.springframework.data.redis.core.RedisTemplate;

import java.util.*;
import java.util.concurrent.TimeUnit;

/**
 * Created by JQ.bi on 2020.8.28
 */
public class SmsUtil {

    //appId
    public static final int appId = 1400418108;
    //appKey
    public static final String appKey = "f0e35b6a89e81673c37a03db086a7133";
    //短信模板Id
    public static final int msgTempId = 704669;
    //签名内容
    public static final String smsSign  = "优容智汇";
    //每日最大发送条数
    public static final int SMS_COUNT = 10;
    //手机号前缀
    public static final String phonePrefix="86";

    //生成redis key
    public static String getRedisSmsKey(String scenename, String phoneNumber) {
        return "sms::" + phoneNumber + "::" + scenename;
    }

    //获取redis value
    public static Map<String, Object> getRedisSmsValue(RedisTemplate redisTemplate, String redis_sms_key) {
        return (Map<String, Object>) redisTemplate.opsForHash().entries(redis_sms_key);
    }

    //更新redis 值
    public static void updateRedisSmsValue(RedisTemplate redisTemplate, String redis_sms_key, Map<String, Object> data) {
        redisTemplate.opsForHash().putAll(redis_sms_key,data);
        redisTemplate.expire(redis_sms_key,getDayEndTime()-(Long)data.get("sendTime"), TimeUnit.MILLISECONDS);
    }

    //拼装redis value
    public static Map<String, Object> joinRedisData(String code, long sendTime, int count,boolean isVerify) {
        Map<String, Object> data = new HashMap<>();
        data.put("code", code);
        data.put("sendTime", sendTime);
        data.put("count", count);
        data.put("isVerify",isVerify);
        return data;
    }
    //获取当天24点时间戳
    private static long getDayEndTime() {
        Calendar c = Calendar.getInstance();
        c.setTime(new Date());
        //将小时至23
        c.set(Calendar.HOUR_OF_DAY, 23);
        //将分钟至59
        c.set(Calendar.MINUTE, 59);
        //将秒至59
        c.set(Calendar.SECOND, 59);
        //将毫秒至999
        c.set(Calendar.MILLISECOND, 999);
        // 获取本月最后一天的时间戳
        return c.getTimeInMillis();
    }

    //自定义返回类型
    public static Map<String, Object> smsResp(boolean isSuccess, Map<String, String> data) {
        Map<String, Object> result = new HashMap<>();
        Map<String, Object> head = new HashMap<>();
        if (isSuccess) {
            head.put("code", 200);
            head.put("msg", "操作成功");
            result.put("head", head);
            result.put("body", data);
        } else {
            head.put("code", 500);
            head.put("msg", "操作失败");
            result.put("head", head);
            result.put("body", data);
        }
        return result;
    }
    //自定义封装错误码
    public static String mappingErrorCode(String key){
        String errorMsg="";
        switch (key){
            case "isv.MOBILE_NUMBER_ILLEGAL":
                errorMsg= "非法手机号";
            case "isv.BUSINESS_LIMIT_CONTROL":
                errorMsg= "业务限流(每小时5条)";
            case "isv.MOBILE_COUNT_OVER_LIMIT":
                errorMsg= "手机号码数量超过限制";
        }
        return errorMsg;
    }
}
